#	Program:	makeSPC_Graphs.AWK
#
#	Author:         Dave Femia
#                       Integral Engineering
#                       dfemia@integral.usa1.com
#                       508.448.2894 (Pager 800.592.0933)
#
#       Date:           Rev.1           August 8, 1995
#
#       Purpose:        Open both the ..../Jobs/item.op.RAW and
#                       ..../Machines/item.op.RAW files and create the
#                       following:
#                               1)      Create graphs
#
#START BEGIN
BEGIN{
	FS="~"
	i = 1
	while(getline < "Chars.SED"> 0 ) {

		ITEM_NO[i]		= $1
		PROCESS_REV_NO[i]	= $2
		OPER_NO[i]		= $3
		PLAN_REV_NO[i]		= $4
		STEP_NO[i]		= $5
		STEP_DESC[i]		= $6
		CLASS[i]		= $7
		SUB_SIZE[i]		= $8
		GAGE_NAME[i]		= $9
		GAGE_NO[i]		= $10
		CHANNEL[i]		= $11
		NUM_CHARS[i]		= $12
		PORT_ID[i]		= $13
		BAUD_RATE[i]		= $14
		DATABITS[i]		= $15
		STOP_BITS[i]		= $16
		PARITY[i]		= $17
		START_STRING[i]		= $18
		STOP_STRING[i]		= $19
		EOM[i]			= $20
		DEC_PL[i]		= $21
		TAPE_NO[i]		= $22
		UPPER_SPEC[i]		= $23
		LOWER_SPEC[i]		= $24
		NOMINAL_VALUE[i]	= $25
		NOMINAL_UNITS[i]	= $26
		UPPER_FLYER[i]		= $27
		LOWER_FLYER[i]		= $28
		TARGET_VALUE[i]		= $29
		NO_MEAS[i]		= $30
		PRE_UCL[i]		= $31
		PRE_LCL[i]		= $32
		SPC[i]			= $33
		DATA_COLLECT[i]		= $34
		MEAS_ID[i]		= $35
		OPER_SUFX[i]		= $36

		ACTUAL_USL[i]		= NOMINAL_VALUE[i] + UPPER_SPEC[i]
		ACTUAL_LSL[i]		= NOMINAL_VALUE[i] - LOWER_SPEC[i]

		DIFF[i]			= ( ACTUAL_USL[i] - ACTUAL_LSL[i] ) / 2.0

		if ( DEC_PL[i] == "null" ) {
			DEC_PL[i] = 3
			}

		if ( UPPER_FLYER[i] == "null" ) {
			ACTUAL_UP_FLY[i]        = ACTUAL_USL[i]
			}
		else
			{
			ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] + UPPER_FLYER[i]
			}

		if ( LOWER_FLYER[i] == "null" ) {
			ACTUAL_LOW_FLY[i]	= ACTUAL_LSL[i]
			}
		else
			{
			ACTUAL_LOW_FLY[i]       = NOMINAL_VALUE[i] - LOWER_FLYER[i]
			} 

		
		printf("Orig:  USL: %s NOM: %s LSL: %s \n", UPPER_SPEC[i], NOMINAL_VALUE[i], LOWER_SPEC[i] )	
		printf("USL: %s NOM: %s LSL: %s UFL: %s LFL:%s \n",ACTUAL_USL[i],NOMINAL_VALUE[i],ACTUAL_LSL[i],ACTUAL_UP_FLY[i],ACTUAL_LOW_FLY[i] )

		++i
	}
	print("\n")
	print("Beginning of Main \n")
	print("\n")
}
#END BEGIN
######################################################################################
# Main
{
#	Send msgs to CELLman to create data structures

	PH		=	sprintf("P")
	SPCtmpl		=	sprintf("%s/%s.SPT", SPCdir, NAME )
	

	tmpNR		=	NR
	printf("TempNR  %s \n", tmpNR)

	BatchSzRun	=	CNTSUBS * 3
	DrawBatchRun	=	CNTPNTS
	BatchSzSubgrp	= 	CNTSUBS
	DrawBtchSubgrp	=	CNTSUBS

	charts		=	sprintf("%s/Charts.DB", SPCdir )

	printf("Record:  %s \n", NR )

	if( tmpNR == 1 ) 
	{
		remove		=	sprintf("rm %s", charts)
		system(remove)
		print("\n") 	> 	charts
	}

	for(i = 1; i <= CNT; ++i)
		{

			trace = sprintf("CWtrace -n trace1 Creating %s graph", i )
			system(trace)

			print("i = " i )
			GraphName	=	sprintf("%s.%s", STEP_NO[i], $1 )
			CharDesc	=	sprintf("\"%s  %s\"", STEP_NO[i], substr(STEP_DESC[i],1,40) )
			MachName	=	sprintf("\"%s  %s\"", $1, $3 )
			VertRngBotRun	= 	NOMINAL_VALUE[i] - ( ( 1.0 + Yfactor) * DIFF[i] )
			VertRngTopRun	= 	NOMINAL_VALUE[i] + ( ( 1.0 + Yfactor) * DIFF[i] )

			VertRngBotXbar	= 	NOMINAL_VALUE[i] - ( ( 1.0 + Yfactor) * DIFF[i] )
			VertRngTopXbar	= 	NOMINAL_VALUE[i] + ( ( 1.0 + Yfactor) * DIFF[i] )

			VertRngBotRang	=	0.0
			VertRngTopRang	=	DIFF[i] * ( 1.0 + Yfactor)
			VertRngBotSgma	=	0.0
			VertRngTopSgma	=	DIFF[i] / 5.0
			
			PreCntrlXoLow	=	NOMINAL_VALUE[i] - ( DIFF[i] / 2.0 )
			PreCntrlXoHigh	= 	NOMINAL_VALUE[i] + ( DIFF[i] / 2.0 )
			

			MSG = sprintf("chart %s x=0 y=0 %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s ",SPCtmpl, GraphName, CharDesc, MachName, NOMINAL_VALUE[i], PH, PH, PH, PH, PH, SUB_SIZE[i], BatchSzRun, DrawBatchRun, VertRngBotRun, VertRngTopRun, BatchSzSubgrp, DrawBtchSubgrp, VertRngBotXbar, VertRngTopXbar, VertRngBotRang, VertRngTopRang, VertRngBotSgma, VertRngTopSgma, PH, PH, PH, PH, PH, PH, DEC_PL[i], ACTUAL_USL[i], ACTUAL_LSL[i], NOMINAL_VALUE[i], PreCntrlXoLow, PreCntrlXoHigh, ACTUAL_UP_FLY[i], ACTUAL_LOW_FLY[i], PH, PH, PH, PH )
 
			printf(MSG "\n")	>> 	charts
		}

}
# End Main
#####################################################################################
END{


# Message to load Charts.DB into SPCsrv
	MSG = sprintf("\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s -r %s SPCsrv include %s +quiet", MBX, REPLYBOX, charts )
	printf(MSG "\n")
	system(MSG)

	trace = sprintf("CWtrace -n trace1 Sending include message to SPCsrv")
	system(trace)

# Set up reply message to confirm completion of graph creation.
	MSG = sprintf("\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s -r %s SPCsrv ping", MBX, REPLYBOX )
	printf(MSG "\n")
	system(MSG)

	trace = sprintf("CWtrace -n trace Ping sent to SPCsrv")
	system(trace)


}
